angular.module('beamng.apps')
  .directive('usedCarGenerator', [function () {
    return {
      templateUrl:
        '/ui/modules/apps/usedCarGenerator/app.html',
      replace: true,
      restrict: 'EA',
      scope: true,
      controller: ['$log', '$scope', function ($log, $scope) {

        $scope.setting_condition;
        $scope.setting_mileage;
        $scope.setting_parkchance = 0.15;
        $scope.setting_usepopulation = true;
        $scope.setting_moddedcars = false;
        $scope.setting_maxyear;

        $scope.setting_seed;
        $scope.setting_balance = true;
        $scope.setting_wearvariation = 0.35;
        $scope.setting_showinfo = true;
        $scope.setting_showvehiclestate = true;
        $scope.setting_showdistance = true;

        $scope.displayInfo = [];

        var configs = {};
        var attempts = 0;

        $scope.spawnBarnfind = (spawnHere) => {
          $scope.displayInfo = [{ name1: "Loading...", val1: "", name2: "Loading...", val2: "" }];
          makeDataDisplayable($scope.displayInfo)

          configs = {
            Condition: $scope.setting_condition,
            Mileage: $scope.setting_mileage,
            ParkChance: $scope.setting_parkchance,
            UsePopulation: $scope.setting_usepopulation,
            ModCars: $scope.setting_moddedcars,
            MaxYear: $scope.setting_maxyear,
            Seed: $scope.setting_seed,
            Balance: $scope.setting_balance,
            WearVar: $scope.setting_wearvariation,
            ShowInfo: $scope.setting_showinfo,
            ShowState: $scope.setting_showvehiclestate,
            ShowDist: $scope.setting_showdistance
          }

          let str = ""
          for (const key in configs) {
            str += `${key} = ${configs[key] != null ? configs[key] : 'nil'},`
          }

          setTimeout(() => bngApi.engineLua(`(function() return barnfindGenerator.spawnBarnfind({${str} SpawnHere = ${spawnHere}}) end) ()`, function (data) {
            if (data == null) { 
              $scope.displayInfo = [{ name1: "Loading Failed.", val1: "", name2: "Loading Failed.", val2: "" }];
              makeDataDisplayable($scope.displayInfo)
              return 
            }

            let keyInfo = Object.keys(data)
            let valInfo = Object.values(data)

            attempts = 0;
            setTimeout(function () {
              queueWearInfo(keyInfo, valInfo)
            }, 500);
          }), 50)
        }

        var queueWearInfo = function (keyInfo, valInfo) {
          setTimeout(() => bngApi.engineLua(`(function() return barnfindGenerator.getWearInfo() end) ()`, function (data) {
            if (data == null) {
              if (attempts < 10) {
                attempts++
                queueWearInfo()
              } else {
                $scope.displayInfo = [{ name1: "Loading Failed.", val1: "", name2: "Loading Failed.", val2: "" }];
                makeDataDisplayable($scope.displayInfo)
              }
              return
            }

            let keyWear = Object.keys(data)
            let valWear = Object.values(data)

            $scope.displayInfo = updateDisplayData(keyInfo, valInfo, keyWear, valWear)
            makeDataDisplayable($scope.displayInfo)
          }), 500)
        }

        var makeDataDisplayable = function (display) {
          $scope.$evalAsync(function () {
            $scope.displayInfo = display
          })
        }

        var updateDisplayData = function (ki, vi, kw, vw) {
          let fullData = []

          for (let i = 0; i < Math.max(ki.length, kw.length); i++) {
            let sI = configs.ShowInfo
            let sW = $scope.setting_showvehiclestate
            let realKw = ""
            if (kw[i]) {
              let str = kw[i].replace("__", " - ")
              realKw = str.replace("_", " ")
            }

            fullData[i] = { name1: (sI && ki[i] ? ki[i] : ""), val1: (sI && vi[i] ? vi[i] : ""), name2: (sW && kw[i] ? realKw : ""), val2: (sW && vw[i] ? vw[i] : "") }
          }

          return fullData
        }

        $scope.regenPrevious = () => {
          bngApi.engineLua(`extensions.barnfindGenerator.respawnPrev()`)
        }

        $scope.reapplyConditions = () => {
          bngApi.engineLua(`local veh = be:getPlayerVehicle(0)
            if veh then
             veh:queueLuaCommand("extensions.barnfindGenerator.resetBarnfind()")
            else
              guihooks.message("ERROR: There are no vehicles in the level!", 8, "barnfindGenerator.error.noVehicleFound")
            end`
          )
        }
      }
      ]
    }
  }]);